// ConnectionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Pekechat.h"
#include "ConnectionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SERVER_CTRLS_NUMBER	1
int ServerCtrls [] = {IDC_CLIENT_NUMBER_EDIT};

#define CLIENT_CTRLS_NUMBER	2
int ClientCtrls [] = {IDC_IPADDRESS, IDC_REMOTE_PORT};


CConnectionDlg::CConnectionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConnectionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConnectionDlg)
	m_ClientNumber = 0;
	m_NickName = _T("");
	m_IPAddress = _T("");
	m_LocalPort = 0;
	m_RemotePort = 0;
	//}}AFX_DATA_INIT
	m_IsServer = true;
}


void CConnectionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectionDlg)
	DDX_Text(pDX, IDC_CLIENT_NUMBER_EDIT, m_ClientNumber);
	DDV_MinMaxInt(pDX, m_ClientNumber, 0, 500);
	DDX_Text(pDX, IDC_NICK_EDIT, m_NickName);
	DDV_MaxChars(pDX, m_NickName, 20);
	DDX_Text(pDX, IDC_IPADDRESS, m_IPAddress);
	DDV_MaxChars(pDX, m_IPAddress, 15);
	DDX_Text(pDX, IDC_LOCAL_PORT, m_LocalPort);
	DDV_MinMaxInt(pDX, m_LocalPort, 0, 32000);
	DDX_Text(pDX, IDC_REMOTE_PORT, m_RemotePort);
	DDV_MinMaxInt(pDX, m_RemotePort, 0, 32000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConnectionDlg, CDialog)
	//{{AFX_MSG_MAP(CConnectionDlg)
	ON_BN_CLICKED(IDC_SERVER_RADIO, OnServerRadio)
	ON_BN_CLICKED(IDC_CLIENT_RADIO, OnClientRadio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CConnectionDlg::OnOK() 
{
	UpdateData ();

	CDialog::OnOK();
}

BOOL CConnectionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CButton *pButton;
	int Count;

	pButton = (CButton *)GetDlgItem (IDC_SERVER_RADIO);
	pButton -> SetCheck (TRUE);

	for (Count = 0; Count < CLIENT_CTRLS_NUMBER; Count ++)
		GetDlgItem (ClientCtrls [Count]) -> EnableWindow (FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConnectionDlg::OnServerRadio() 
{
	int Count;

	for (Count = 0; Count < SERVER_CTRLS_NUMBER; Count ++)
		GetDlgItem (ServerCtrls [Count]) -> EnableWindow ();
	for (Count = 0; Count < CLIENT_CTRLS_NUMBER; Count ++)
		GetDlgItem (ClientCtrls [Count]) -> EnableWindow (FALSE);

	m_IsServer = true;
}

void CConnectionDlg::OnClientRadio() 
{
	int Count;

	for (Count = 0; Count < SERVER_CTRLS_NUMBER; Count ++)
		GetDlgItem (ServerCtrls [Count]) -> EnableWindow (FALSE);
	for (Count = 0; Count < CLIENT_CTRLS_NUMBER; Count ++)
		GetDlgItem (ClientCtrls [Count]) -> EnableWindow ();

	m_IsServer = false;
}
