// ConnectionManager.h

#ifndef _CONNECTIONMANAGER_H_
#define _CONNECTIONMANAGER_H_

#include <winsock2.h>

#define MAX_CLIENT_NUMBER 100

#define CONNECTION_NO_DATA 10

class CConnectionManager
{
	unsigned short LocalPort;
	unsigned short RemotePort;
	sockaddr_in LocalAddress;
	WSADATA wsaData;
	SOCKET Socket;
	hostent *Host;

	int MsgSize;
	int WorkMode;
	int ClientsNumber; // Maximun clients allowed
	int ClientCount; // How many clients are currently connected
	sockaddr_in *ClientArray;

	sockaddr_in LastClient;

	char ErrorMsg [500];
public:
	CConnectionManager ();
	~CConnectionManager ();

	// Server functions
	int InitServer (unsigned short LocalPort, int ClientsNumber);
	int SendToClient (const char *Buffer, int ClientIndex);
	int SendAllClients (const char *Buffer, int Except = -1);
	int SendLastClient (const char *Buffer);
	int ReceiveFromClient (char *Buffer, int *ClientIndex);
	int AcceptLastClient ();
	int DeleteClient (int ClientIndex);
	int GetClientIP (char *IP, int ClientId);

	// Client functions
	int InitClient (const char *IP, unsigned short LocalPort, unsigned short RemotePort);
	int SendToServer (const char *Buffer);
	int ReceiveFromServer (char *Buffer);

	void ShutDown ();

	void SetMsgSize (int Size);

	char *GetErrorMsg ();
};

#endif;